sub gen_char() {
	my ($n)=@_;
	my ($letter,@s);

	# ʸ /[a-z0-9]{$n}/
	$letter="";
	@s=split(//,q[abcdefghigklmnopqrstuvwxyz0123456789]);
	for(1..$n) {
		$letter.=$s[rand(scalar(@s))];
	}
	return $letter;
}

sub gen_alpha() {
	my ($n)=@_;
	my ($letter,@s);

	# ʸ /[a-z]{$n}/
	$letter="";
	@s=split(//,q[abcdefghigklmnopqrstuvwxyz]);
	for(1..$n) {
		$letter.=$s[rand(scalar(@s))];
	}
	return $letter;
}

sub gen_num() {
	my ($n)=@_;
	my ($letter,@s);

	# ʸ /[0-9]{$n}/
	$letter="";
	@s=split(//,q[0123456789]);
	for(1..$n) {
		$letter.=$s[rand(scalar(@s))];
	}
	return $letter;
}

sub gen_id() {
	my ($n)=@_;
	my ($letter,@s,$i,$j);

	# ʸ /[a-z][0-9a-z]{$n-1}/
	$letter="";
	$i=1;
	$j=$n-$i;
	@s=split(//,q[abcdefghigklmnopqrstuvwxyz]);
	for(1..$i) {
		$letter.=$s[int(rand(scalar(@s)))];
	}
	@s=split(//,q[0123456789abcdefghigklmnopqrstuvwxyz]);
	for(1..$j) {
		$letter.=$s[int(rand(scalar(@s)))];
	}
	return $letter;
}

sub gen_pass() {
	my ($n)=@_;

	# &gen_id()Ʊ
	return &gen_id($n);
}

sub gen_alnum() {
	my ($n)=@_;
	my ($letter,@s,$i,$j);

	# ʸ /[a-z]{$i}[0-9_]{$j}/
	$letter="";
	$i=int(rand($n));
	$i=1 if($i==0);
	$j=$n-$i;
	@s=split(//,q[abcdefghigklmnopqrstuvwxyz]);
	for(1..$i) {
		$letter.=$s[int(rand(scalar(@s)))];
	}
	@s=split(//,q[0123456789_]);
	for(1..$j) {
		$letter.=$s[int(rand(scalar(@s)))];
	}
	return $letter;
}

1;
