require 'http.pl';
require 'jcode.pl';
require 'strenc.pl';

require 'migr_gifreader.pl';

sub mixi_login() {
	my ($mail,$pass)=@_;
	my ($errmsg,$success);
	my ($page,$referer,%cookie,$postdata,$boundary);
	my ($content,$header);
	my (%hiddendata);

	# ȥåץڡ
	$page="http://mixi.jp/login.pl";
	$referer="http://mixi.jp/";
	%cookie=();
	$postdata="";

	$postdata.="next_url=/home.pl";
	$postdata.="&email=$mail";
	$postdata.="&password=$pass";

	($content,$header)=&http_post($page,$referer,\%cookie,$postdata);
	$referer=$page;

	$errmsg=&mixi_errmsg($content,$header,$referer);
	if($errmsg=~/󤷤ޤ/){
		$errmsg="mixi : OK";
		$errmsg.=" (id=$mail)" if($warning);
		print "$errmsg<br>\n";
	}
	else {
		$errmsg="mixi : NG";
		$errmsg.=" (id=$mail)" if($warning);
		print "$errmsg<br>\n";
		return ($errmsg,0);
	}

	&save_cookie(\%cookie,$mail,"mixi.jp");

	return ($errmsg,1);
}

sub mixi_logout() {
	my ($mail)=@_;
	my ($errmsg,$success);
	my ($page,$referer,%cookie,$postdata,$boundary);
	my ($content,$header);
	my (%hiddendata);

	# 
	$page="http://mixi.jp/logout.pl";
	$referer="http://mixi.jp/home.pl";
	%cookie=();
	$postdata="";

	&load_cookie(\%cookie,$mail,"mixi.jp");

	($content,$header)=&http_get($page,$referer,\%cookie);
	$referer=$page;

	$errmsg="mixiȤޤ";
	$errmsg.=" (id=$mail)" if($warning);
	print "$errmsg<br>\n";

	# å
	&delete_cookie(\%cookie,$mail,"mixi.jp");

	return ($errmsg,1);
}

sub mixi_get_myid() {
	my ($mail)=@_;
	my ($errmsg,$success);
	my ($page,$referer,%cookie,$postdata,$boundary);
	my ($content,$header);
	my (%hiddendata);

	# ޥץեǧ
	$page="http://mixi.jp/home.pl";
	$referer="http://mixi.jp/home.pl";
	%cookie=();
	$postdata="";

	&load_cookie(\%cookie,$mail,"mixi.jp");

	($content,$header)=&http_get($page,$referer,\%cookie);
	$referer=$page;

	if($content=~/<a href="show_profile.pl\?id=(\d+)"/) {
		$errmsg="mixiޥץեǧ : OK";
		$errmsg.=" ($1)" if($warning);
		print "$errmsg<br>\n";
	}
	else {
		$errmsg="mixiޥץեǧ : NG ($errmsg)";
		print "$errmsg<br>\n";
		return ($errmsg,0,"");
	}

	return ($errmsg,1,$1);
}

sub mixi_edit_photo() {
	my ($mail,$imagefile)=@_;
	my ($errmsg,$success);
	my ($page,$referer,%cookie,$postdata,$boundary);
	my ($content,$header);
	my (%hiddendata);
	my (@myphoto,$num_myphoto_after,$num_myphoto_before);

	# ̿Խ
	$page="http://mixi.jp/edit_photo.pl";
	$referer="http://mixi.jp/home.pl";
	%cookie=();
	$postdata="";

	&load_cookie(\%cookie,$mail,"mixi.jp");

	($content,$header)=&http_get($page,$referer,\%cookie);
	$referer=$page;

	$errmsg=&mixi_errmsg($content,$header,$referer);
	if($errmsg=~/̿Խ/) {
		$errmsg="mixi̿Խ : OK ($errmsg)";
		print "$errmsg<br>\n";
	}
	else {
		$errmsg="mixi̿Խ : NG ($errmsg)";
		print "$errmsg<br>\n";
		return ($errmsg,0);
	}

	# ̿򥢥åץ
	@myphoto=($content=~/<a href=(delete_photo.pl\?number=\d+&post_key=[0-9a-z]+)>/ig);
	$num_myphoto_before=scalar(@myphoto);

	$boundary="---------------------------".int(rand(100000000000000));
	$postdata="";
	if(&load_file($imagefile,\$imgbuf)==1) {
		$postdata.="--$boundary\r\n";
		$postdata.="content-disposition: form-data; name=\"photo\"; filename=\"$imagefile\"\r\n";
		$postdata.="content-type: image/jpeg\r\n\r\n";
		$postdata.="$imgbuf\r\n";
		$postdata.="--$boundary--";
	}
	else {
		$errmsg="mixi̿Խ : NG ( $imagefile 򳫤ޤ)";
		print "$errmsg<br>\n";
		return ($errmsg,0);
	}

	($content,$header)=&http_post_multi($page,$referer,\%cookie,$postdata,$boundary);
	$referer=$page;

	# åץɸå
	@myphoto=($content=~/<a href=(delete_photo.pl\?number=\d+&post_key=[0-9a-z]+)>/ig);
	$num_myphoto_after=scalar(@myphoto);

	$errmsg=&mixi_errmsg($content,$header,$referer);
	if($errmsg=~/̿Խ/ && ($num_myphoto_after-$num_myphoto_before)==1) {
		$errmsg="mixi̿Խ : OK (åץɴλ)";
		print "$errmsg<br>\n";
	}
	else {
		$errmsg="mixi̿Խ : NG ($errmsg)";
		print "$errmsg<br>\n";
		return ($errmsg,0);
	}

	return ($errmsg,1);
}

sub mixi_delete_photo() {
	my ($mail,$number)=@_;
	my ($errmsg,$success);
	my ($page,$referer,%cookie,$postdata,$boundary);
	my ($content,$header);
	my (%hiddendata);
	my (@myphoto,$num_myphoto_after,$num_myphoto_before);

	# ̿Խ
	$page="http://mixi.jp/edit_photo.pl";
	$referer="http://mixi.jp/home.pl";
	%cookie=();
	$postdata="";

	&load_cookie(\%cookie,$mail,"mixi.jp");

	($content,$header)=&http_get($page,$referer,\%cookie);
	$referer=$page;

	$errmsg=&mixi_errmsg($content,$header,$referer);
	if($errmsg=~/̿Խ/) {
		$errmsg="mixi̿ : OK ($errmsg)";
		print "$errmsg<br>\n";
	}
	else {
		$errmsg="mixi̿ : NG ($errmsg)";
		print "$errmsg<br>\n";
		return ($errmsg,0);
	}

	# ̿
	@myphoto=($content=~/<a href=(delete_photo.pl\?number=\d+&post_key=[0-9a-z]+)>/ig);
	$num_myphoto_before=scalar(@myphoto);

	if(scalar(@myphoto)>=$number && $number>=1) {
		$errmsg="mixi̿ : OK ($number ܤޤ)";
		print "$errmsg<br>\n";
	}
	else {
		$errmsg="mixi̿ : NG (ꤷǥå¸ߤޤ)";
		print "$errmsg<br>\n";
		return ($errmsg,0);
	}

	$page="http://mixi.jp/".$myphoto[$number-1];

	($content,$header)=&http_get($page,$referer,\%cookie);
	$referer=$page;

	# å
	$page="http://mixi.jp/edit_photo.pl";
	$referer="http://mixi.jp/home.pl";

	($content,$header)=&http_get($page,$referer,\%cookie);
	$referer=$page;

	@myphoto=($content=~/<a href=(delete_photo.pl\?number=\d+&post_key=[0-9a-z]+)>/ig);
	$num_myphoto_after=scalar(@myphoto);

	$errmsg=&mixi_errmsg($content,$header,$referer);
	if($errmsg=~/̿Խ/ && ($num_myphoto_before-$num_myphoto_after)==1) {
		$errmsg="mixi̿ : OK (λ)";
		print "$errmsg<br>\n";
	}
	else {
		$errmsg="mixi̿ : NG ($errmsg)";
		print "$errmsg<br>\n";
		return ($errmsg,0);
	}

	return ($errmsg,1);
}

sub mixi_invite() {
	my ($mail,$invitee,$message,$check_only)=@_;
	my ($errmsg,$success);
	my ($page,$referer,%cookie,$postdata,$boundary);
	my ($content,$header);
	my (%hiddendata);
	my ($auth_number,$invite_key);

	# ͧͤmixi˾Ԥ
	$page="http://mixi.jp/invite.pl";
	$referer="http://mixi.jp/home.pl";
	%cookie=();
	$postdata="";

	&load_cookie(\%cookie,$mail,"mixi.jp");

	($content,$header)=&http_get($page,$referer,\%cookie);
	$referer=$page;

	$errmsg=&mixi_errmsg($content,$header,$referer);
	if($errmsg=~/ͧͤ mixi ˾Ԥ/) {
		$errmsg="mixiͧͤ : OK ($errmsg)";
		print "$errmsg<br>\n";
	}
	else {
		$errmsg="mixiͧͤ : NG ($errmsg)";
		print "$errmsg<br>\n";
		return ($errmsg,0);
	}

	# ѥ᡼륢ɥ쥹
	$postdata="";
	$postdata.="submit=main";
	$postdata.="&email=$invitee";

	($content,$header)=&http_post($page,$referer,\%cookie,$postdata);
	$referer=$page;

	$errmsg=&mixi_errmsg($content,$header,$referer);
	if($errmsg=~/ʤξԥåƲ/) {
		$errmsg="mixiͧͤ : OK ($errmsg)";
		print "$errmsg<br>\n";
	}
	else {
		$errmsg="mixiͧͤ : NG ($errmsg)";
		print "$errmsg<br>\n";
		return ($errmsg,0);
	}

	# ԵǽåΤߤξ
	if(defined $check_only && $check_only) {
		return ($errmsg,1);
	}

	# ԥå
	%hiddendata=($content=~/<input(?: type=hidden)? name="?([^\s"]*)"? value="?([^>"]*)"?/g);
	$hiddendata{'last_name'}=&url_encode($hiddendata{'last_name'});
	$hiddendata{'first_name'}=&url_encode($hiddendata{'first_name'});

	$postdata="";
	$postdata=join('&',map{"$_=$hiddendata{$_}"}keys %hiddendata);
	$postdata.="&message=".&url_encode($message);

	# ǧ
	$invite_key=$hiddendata{'invite_key'};
	($success,$auth_number)=&migr_gifreader($invite_key);
	if($success==0) {
		$errmsg="mixiͧͤ : NG (ǧֹɤǤޤǤ expected:$auth_number http://mixi.jp/data/gif/$invite_key.gif)";
		print "$errmsg<br>\n";
		return ($errmsg,0);
	}
	$postdata.="&number=".sprintf("%04d",$auth_number);

	($content,$header)=&http_post($page,$referer,\%cookie,$postdata);
	$referer=$page;

	$errmsg=&mixi_errmsg($content,$header,$referer);
	if($errmsg=~/λޤ/) {
		$errmsg="mixiͧͤ : OK ($errmsg)";
		print "$errmsg<br>\n";
	}
	else {
		$errmsg="mixiͧͤ : NG ($errmsg expected:$auth_number http://mixi.jp/data/gif/$invite_key.gif)";
		print "$errmsg<br>\n";
		if($errmsg=~/ֹϤƲ/) {
			if(open OUT,">>$datadir/migr_failed.txt") {
				print OUT "http://mixi.jp/data/gif/$invite_key.gif\t$auth_number\n";
				close OUT;
			}
		}
		return ($errmsg,0);
	}

	return ($errmsg,1);
}

sub mixi_invite_check() {
	return &mixi_invite(@_,1);
}

sub mixi_join_community() {
	my ($mail,$comm_id)=@_;
	my ($errmsg,$success);
	my ($page,$referer,%cookie,$postdata,$boundary);
	my ($content,$header);
	my (%hiddendata);

	# ߥ˥ƥ˻
	$page="http://mixi.jp/join_community.pl?id=$comm_id";
	$referer="http://mixi.jp/view_community.pl?id=$comm_id";
	%cookie=();
	$postdata="";

	&load_cookie(\%cookie,$mail,"mixi.jp");

	($content,$header)=&http_get($page,$referer,\%cookie);
	$referer=$page;

	$errmsg=&mixi_errmsg($content,$header,$referer);
	if($errmsg=~/ˤΥߥ˥ƥ˻äƤޤ/) {
		$_=$errmsg;
		$errmsg="mixiߥ˥ƥ˻";
		$errmsg.=" ($comm_id)" if($warning);
		$errmsg.=" : OK ($_)";
		print "$errmsg<br>\n";
		return ($errmsg,1);
	}
	elsif($errmsg=~/˻äޤ\?/) {
		$_=$errmsg;
		$errmsg="mixiߥ˥ƥ˻";
		$errmsg.=" ($comm_id)" if($warning);
		$errmsg.=" : OK ($_)";
		print "$errmsg<br>\n";
	}
	elsif($errmsg=~/Υߥ˥ƥ˻ä뤿ˤϴԤξǧɬפǤ/) {
		$_=$errmsg;
		$errmsg="mixiߥ˥ƥ˻";
		$errmsg.=" ($comm_id)" if($warning);
		$errmsg.=" : NG ($_)";
		print "$errmsg<br>\n";
		return ($errmsg,0);
	}
	else {
		$_=$errmsg;
		$errmsg="mixiߥ˥ƥ˻";
		$errmsg.=" ($comm_id)" if($warning);
		$errmsg.=" : NG ($_)";
		print "$errmsg<br>\n";
		return ($errmsg,0);
	}

	# ߥ˥ƥ˻óǧ
	%hiddendata=($content=~/<input type="?hidden"? name="?([^\s"]*)"? value="?([^>"]*)"?/g);

	$postdata="";
	$postdata=join('&',map{"$_=$hiddendata{$_}"}keys %hiddendata);

	($content,$header)=&http_post($page,$referer,\%cookie,$postdata);
	$referer=$page;

	$errmsg=&mixi_errmsg($content,$header,$referer);
	if($errmsg=~/Υߥ˥ƥ˻äޤ/) {
		$_=$errmsg;
		$errmsg="mixiߥ˥ƥ˻";
		$errmsg.=" ($comm_id)" if($warning);
		$errmsg.=" : OK ($_)";
		print "$errmsg<br>\n";
	}
	else {
		$_=$errmsg;
		$errmsg="mixiߥ˥ƥ˻";
		$errmsg.=" ($comm_id)" if($warning);
		$errmsg.=" : NG ($_)";
		print "$errmsg<br>\n";
		return ($errmsg,0);
	}

	return ($errmsg,1);
}

sub mixi_add_bbs() {
	my ($mail,$comm_id,$bbs_title,$bbs_body,@img)=@_;
	my ($errmsg,$success);
	my ($page,$referer,%cookie,$postdata,$boundary);
	my ($content,$header);
	my (%hiddendata);
	my ($imgfile,$imgbuf,$i);

	# ȥԥå
	$page="http://mixi.jp/add_bbs.pl?id=$comm_id";
	$referer="http://mixi.jp/view_community.pl?id=$comm_id";
	%cookie=();
	$postdata="";

	&load_cookie(\%cookie,$mail,"mixi.jp");

	($content,$header)=&http_get($page,$referer,\%cookie);
	$referer=$page;

	$errmsg=&mixi_errmsg($content,$header,$referer);
	if($errmsg=~/ȥԥå/) {
		$_=$errmsg;
		$errmsg="mixiȥԥå";
		$errmsg.=" ($comm_id)" if($warning);
		$errmsg.=" : OK ($_)";
		print "$errmsg<br>\n";
	}
	else {
		$_=$errmsg;
		$errmsg="mixiȥԥå";
		$errmsg.=" ($comm_id)" if($warning);
		$errmsg.=" : NG ($_)";
		print "$errmsg<br>\n";
		return ($errmsg,0);
	}

	# ǡ
	$boundary="---------------------------".int(rand(100000000000000));
	$postdata="";
	$postdata.=qq|--$boundary\r\n|;
	$postdata.=qq|Content-Disposition: form-data; name="submit"\r\n\r\n|.qq|main\r\n|;
	$postdata.=qq|--$boundary\r\n|;
	$postdata.=qq|Content-Disposition: form-data; name="bbs_title"\r\n\r\n|.&url_encode($bbs_title).qq|\r\n|;
	$postdata.=qq|--$boundary\r\n|;
	$postdata.=qq|Content-Disposition: form-data; name="bbs_body"\r\n\r\n|.&url_encode($bbs_body).qq|\r\n|;

	$i=0;
	foreach $imgfile(@img) {
		$i++;
		last if($i==4); #3ޤ
		if($imgfile) {
			if(&load_file($imgfile,\$imgbuf)==0) {
				$errmsg="mixiȥԥå";
				$errmsg.=" ($comm_id)" if($warning);
				$errmsg.=" : NG ( '$imgfile' 򳫤ޤ)";
				print "$errmsg<br>\n";
				return ($errmsg,0);
			}
			$postdata.=qq|--$boundary\r\n|;
			$postdata.=qq|Content-Disposition: form-data; name="photo$i"; filename="$imgfile"\r\n|;
			$postdata.=qq|Content-Type: image/jpeg\r\n\r\n|.qq|$imgbuf\r\n|;
		}
		else {
			$postdata.=qq|--$boundary\r\n|;
			$postdata.=qq|Content-Disposition: form-data; name="photo$i"; filename=""\r\n|;
			$postdata.=qq|Content-Type: application/octet-stream\r\n\r\n|;
		}
	}
	$postdata.="--$boundary--";

	($content,$header)=&http_post_multi($page,$referer,\%cookie,$postdata,$boundary);
	$referer=$page;

	$errmsg=&mixi_errmsg($content,$header,$referer);
	print "$errmsg<br>\n";

	if($errmsg=~/ʲƤǺޤǤ/) {
		$_=$errmsg;
		$errmsg="mixiȥԥå";
		$errmsg.=" ($comm_id)" if($warning);
		$errmsg.=" : OK ($_)";
		print "$errmsg<br>\n";
	}
	else {
		$_=$errmsg;
		$errmsg="mixiȥԥå";
		$errmsg.=" ($comm_id)" if($warning);
		$errmsg.=" : NG ($_)";
		print "$errmsg<br>\n";
		return ($errmsg,0);
	}

	# ȥԥåǧ
	%hiddendata=($content=~/<input type="?hidden"? name="?([^\s"]*)"? value="?([^>"]*)"?/g);
	$hiddendata{'submit'}="confirm";

	$postdata="";
	$postdata=join('&',map{"$_=$hiddendata{$_}"}keys %hiddendata);

	($content,$header)=&http_post($page,$referer,\%cookie,$postdata);
	$referer=$page;

	$errmsg=&mixi_errmsg($content,$header,$referer);

	if($errmsg=~/λޤ/) {
		$_=$errmsg;
		$errmsg="mixiȥԥå";
		$errmsg.=" ($comm_id)" if($warning);
		$errmsg.=" : OK ($_)";
		print "$errmsg<br>\n";
	}
	else {
		$_=$errmsg;
		$errmsg="mixiȥԥå";
		$errmsg.=" ($comm_id)" if($warning);
		$errmsg.=" : NG ($_)";
		print "$errmsg<br>\n";
		return ($errmsg,0);
	}

	return ($errmsg,1);
}

sub mixi_add_bbs_comment() {
	my ($mail,$comm_id,$topic_id,$comment,@img)=@_;
	my ($errmsg,$success);
	my ($page,$referer,%cookie,$postdata,$boundary);
	my ($content,$header);
	my (%hiddendata);
	my ($imgfile,$imgbuf,$i);

	# ǼĤΥȥԥå˥Ȥ
	$page="http://mixi.jp/add_bbs_comment.pl?id=$topic_id&comm_id=$comm_id";
	$referer="http://mixi.jp/view_bbs.pl?id=$topic_id&comm_id=$comm_id";
	%cookie=();
	$postdata="";

	&load_cookie(\%cookie,$mail,"mixi.jp");

	# ǡ
	$boundary="---------------------------".int(rand(100000000000000));
	$postdata="";
	$postdata.=qq|--$boundary\r\n|;
	$postdata.=qq|Content-Disposition: form-data; name="comment"\r\n\r\n|.&url_encode($comment).qq|\r\n|;

	$i=0;
	foreach $imgfile(@img) {
		$i++;
		last if($i==4); #3ޤ
		if($imgfile) {
			if(&load_file($imgfile,\$imgbuf)==0) {
				$errmsg="mixiȥԥå˽񤭹";
				$errmsg.=" ($comm_id)" if($warning);
				$errmsg.=" : NG ( '$imgfile' 򳫤ޤ)";
				print "$errmsg<br>\n";
				return ($errmsg,0);
			}
			$postdata.=qq|--$boundary\r\n|;
			$postdata.=qq|Content-Disposition: form-data; name="photo$i"; filename="$imgfile"\r\n|;
			$postdata.=qq|Content-Type: image/jpeg\r\n\r\n|.qq|$imgbuf\r\n|;
		}
		else {
			$postdata.=qq|--$boundary\r\n|;
			$postdata.=qq|Content-Disposition: form-data; name="photo$i"; filename=""\r\n|;
			$postdata.=qq|Content-Type: application/octet-stream\r\n\r\n|;
		}
	}
	$postdata.="--$boundary--";

	($content,$header)=&http_post_multi($page,$referer,\%cookie,$postdata,$boundary);
	$referer=$page;

	$errmsg=&mixi_errmsg($content,$header,$referer);
	print "$errmsg<br>\n";

	if($errmsg=~/ʲƤǽ񤭹ߤޤǤ/) {
		$_=$errmsg;
		$errmsg="mixiȥԥå˽񤭹";
		$errmsg.=" ($comm_id)" if($warning);
		$errmsg.=" : OK ($_)";
		print "$errmsg<br>\n";
	}
	else {
		$_=$errmsg;
		$errmsg="mixiȥԥå˽񤭹";
		$errmsg.=" ($comm_id)" if($warning);
		$errmsg.=" : NG ($_)";
		print "$errmsg<br>\n";
		return ($errmsg,0);
	}

	# ȥԥå񤭹߳ǧ
	%hiddendata=($content=~/<input type="?hidden"? name="?([^\s"]*)"? value="?([^>"]*)"?/g);
	$hiddendata{'submit'}="confirm";

	$postdata="";
	$postdata=join('&',map{"$_=$hiddendata{$_}"}keys %hiddendata);

	($content,$header)=&http_post($page,$referer,\%cookie,$postdata);
	$referer=$page;

	$errmsg=&mixi_errmsg($content,$header,$referer);

	if($errmsg=~/񤭹ߤλޤ/) {
		$_=$errmsg;
		$errmsg="mixiȥԥå˽񤭹";
		$errmsg.=" ($comm_id)" if($warning);
		$errmsg.=" : OK ($_)";
		print "$errmsg<br>\n";
	}
	else {
		$_=$errmsg;
		$errmsg="mixiȥԥå˽񤭹";
		$errmsg.=" ($comm_id)" if($warning);
		$errmsg.=" : NG ($_)";
		print "$errmsg<br>\n";
		return ($errmsg,0);
	}

	return ($errmsg,1);
}

sub mixi_list_diary() {
	my ($mail,$friend_id,$number)=@_;
	my ($errmsg,$success);
	my ($page,$referer,%cookie,$postdata,$boundary);
	my ($content,$header);
	my (%hiddendata);
	my (@title,@info);
	my ($title,$diary_id,$res_num);
	my (@diary_list);

	# 
	$page="";
	$referer="";
	%cookie=();
	$postdata="";

	&load_cookie(\%cookie,$mail,"mixi.jp");

	$number=1 if(!$number || $number<1);
	$page="http://mixi.jp/list_diary.pl?page=$number&id=$friend_id";
	$referer="http://mixi.jp/show_friend.pl?id=$friend_id";

	($content,$header)=&http_get($page,$referer,\%cookie);
	$referer=$page;

	$errmsg=&mixi_errmsg($content,$header,$referer);
	if($errmsg=~//) {
		$_=$errmsg;
		$errmsg="mixi";
		$errmsg.=" ($friend_id)" if($warning);
		$errmsg.=" : OK ($_)";
		print "$errmsg<br>\n";
	}
	else {
		$_=$errmsg;
		$errmsg="mixi";
		$errmsg.=" ($friend_id)" if($warning);
		$errmsg.=" : NG ($_)";
		print "$errmsg<br>\n";
		return ($errmsg,0,[]);
	}

	# ȥ,id,ܿͤid,ȿ
	@title=($content=~m!<td bgcolor="#FFF4E0">&nbsp;<a href=[^>]*>([^<]*)</a></td>!g);
	@info=($content=~m!<td ALIGN=right bgcolor=#FFFFFF>\s*<a href="view_diary.pl\?id=(\d+)&owner_id=(\d+)#(?:comment|write)">\((\d+)\)</a>!g);

	while(scalar(@title)>0) {
		$title=shift @title;
		$diary_id=shift @info;
		$friend_id=shift @info;
		$res_num=shift @info;
		push @diary_list,{
			'title'=>$title,
			'diary_id'=>$diary_id,
			'friend_id'=>$friend_id,
			'res_num'=>$res_num
		};
	}

	return ($errmsg,1,\@diary_list);
}

sub mixi_add_comment() {
	my ($mail,$owner_id,$diary_id,$comment_body)=@_;
	my ($errmsg,$success);
	my ($page,$referer,%cookie,$postdata,$boundary);
	my ($content,$header);
	my (%hiddendata);

	# ˥Ȥ
	$page="";
	$referer="";
	%cookie=();
	$postdata="";

	&load_cookie(\%cookie,$mail,"mixi.jp");

	$page="http://mixi.jp/view_diary.pl?id=$diary_id&owner_id=$owner_id";
	$referer="http://mixi.jp/show_friend.pl?id=$owner_id";

	($content,$header)=&http_get($page,$referer,\%cookie);
	$referer=$page;

	$errmsg=&mixi_errmsg($content,$header,$referer);
	if($errmsg=~/Ȥ/) {
		$_=$errmsg;
		$errmsg="mixi˥";
		$errmsg.=" ($owner_id)" if($warning);
		$errmsg.=" : OK ($_)";
		print "$errmsg<br>\n";
	}
	else {
		$_=$errmsg;
		$errmsg="mixi˥";
		$errmsg.=" ($owner_id)" if($warning);
		$errmsg.=" : NG ($_)";
		print "$errmsg<br>\n";
		return ($errmsg,0);
	}

	# Ƚ񤭹
	$page="http://mixi.jp/add_comment.pl?diary_id=$diary_id";

	%hiddendata=($content=~/<input type="?hidden"? name="?([^\s"]*)"? value="?([^>"]*)"?/ig);

	$postdata="";
	$postdata=join('&',map{"$_=$hiddendata{$_}"}keys %hiddendata);
	$postdata.="&comment_body=".&url_encode($comment_body);

	($content,$header)=&http_post($page,$referer,\%cookie,$postdata);
	$referer=$page;

	$errmsg=&mixi_errmsg($content,$header,$referer);
	if($errmsg=~/ΥȤ񤭹ߤޤ/) {
		$_=$errmsg;
		$errmsg="mixi˥";
		$errmsg.=" ($owner_id)" if($warning);
		$errmsg.=" : OK ($_)";
		print "$errmsg<br>\n";
	}
	else {
		$_=$errmsg;
		$errmsg="mixi˥";
		$errmsg.=" ($owner_id)" if($warning);
		$errmsg.=" : NG ($_)";
		print "$errmsg<br>\n";
		return ($errmsg,0);
	}

	# Ƚ񤭹߳ǧ
	$content=~m!<form action="(add_comment.pl\?diary_id=\d+&owner_id=\d+)" method=post>!;
	$page="http://mixi.jp/$1";

	%hiddendata=($content=~/<input type="?hidden"? name="?([^\s"]*)"? value="?([^>"]*)"?/ig);
	$hiddendata{'comment_body'}=&url_encode($hiddendata{'comment_body'}); #ȤΤencode

	$postdata="";
	$postdata=join('&',map{"$_=$hiddendata{$_}"}keys %hiddendata);

	($content,$header)=&http_post($page,$referer,\%cookie,$postdata);
	$referer=$page;

	$errmsg=&mixi_errmsg($content,$header,$referer);
	if($errmsg=~/񤭹ߤλޤ/) {
		$_=$errmsg;
		$errmsg="mixi˥";
		$errmsg.=" ($owner_id)" if($warning);
		$errmsg.=" : OK ($_)";
		print "$errmsg<br>\n";
	}
	else {
		$_=$errmsg;
		$errmsg="mixi˥";
		$errmsg.=" ($owner_id)" if($warning);
		$errmsg.=" : NG ($_)";
		print "$errmsg<br>\n";
		return ($errmsg,0);
	}

	return ($errmsg,1);
}

sub mixi_add_friend() {
	my ($mail,$friend_id,$message)=@_;
	my ($errmsg,$success);
	my ($page,$referer,%cookie,$postdata,$boundary);
	my ($content,$header);
	my (%hiddendata);

	# ޥߥɲ
	$page="";
	$referer="";
	%cookie=();
	$postdata="";

	&load_cookie(\%cookie,$mail,"mixi.jp");

	$page="http://mixi.jp/add_friend.pl?id=$friend_id";
	$referer="http://mixi.jp/show_friend.pl?id=$friend_id";
	$postdata="";

	($content,$header)=&http_get($page,$referer,\%cookie);
	$referer=$page;

	$errmsg=&mixi_errmsg($content,$header,$referer);
	if($errmsg=~/ˤʤΥޥߥǤ/) {
		$_=$errmsg;
		$errmsg="mixiޥߥɲ";
		$errmsg.=" ($friend_id)" if($warning);
		$errmsg.=" : OK ($_)";
		print "$errmsg<br>\n";
		return ($errmsg,1);
	}
	elsif($errmsg=~/ޥߥɲ/) {
		$_=$errmsg;
		$errmsg="mixiޥߥɲ";
		$errmsg.=" ($friend_id)" if($warning);
		$errmsg.=" : OK ($_)";
		print "$errmsg<br>\n";
	}
	else {
		$_=$errmsg;
		$errmsg="mixiޥߥɲ";
		$errmsg.=" ($friend_id)" if($warning);
		$errmsg.=" : NG ($_)";
		print "$errmsg<br>\n";
		return ($errmsg,0);
	}

	# ɲåꥯȤ
	%hiddendata=($content=~/<input type="?hidden"? name="?([^\s"]*)"? value="?([^>"]*)"?/g);

	$hiddendata{submit}="confirm"; #ǧ

	$postdata="";
	$postdata=join('&',map{"$_=$hiddendata{$_}"}keys %hiddendata);
	$postdata.="&message=".&url_encode($message);

	($content,$header)=&http_post($page,$referer,\%cookie,$postdata);
	$referer=$page;

	$errmsg=&mixi_errmsg($content,$header,$referer);
	if($errmsg=~/λ/) {
		$_=$errmsg;
		$errmsg="mixiޥߥɲ";
		$errmsg.=" ($friend_id)" if($warning);
		$errmsg.=" : OK ($_)";
		print "$errmsg<br>\n";
	}
	else {
		$_=$errmsg;
		$errmsg="mixiޥߥɲ";
		$errmsg.=" ($friend_id)" if($warning);
		$errmsg.=" : NG ($_)";
		print "$errmsg<br>\n";
		return ($errmsg,0);
	}

	return ($errmsg,1);
}

sub mixi_send_message() {
	my ($mail,$friend_id,$subject,$body)=@_;
	my ($errmsg,$success);
	my ($page,$referer,%cookie,$postdata,$boundary);
	my ($content,$header);
	my (%hiddendata);

	# å
	$page="";
	$referer="";
	%cookie=();
	$postdata="";

	&load_cookie(\%cookie,$mail,"mixi.jp");

	$page="http://mixi.jp/send_message.pl?id=$friend_id";
	$referer="http://mixi.jp/show_friend.pl?id=$friend_id";
	$postdata="";

	($content,$header)=&http_get($page,$referer,\%cookie);
	$referer=$page;

	$errmsg=&mixi_errmsg($content,$header,$referer);
	if($errmsg=~/å/) {
		$_=$errmsg;
		$errmsg="mixiå";
		$errmsg.=" ($friend_id)" if($warning);
		$errmsg.=" : OK ($_)";
		print "$errmsg<br>\n";
	}
	else {
		$_=$errmsg;
		$errmsg="mixiå";
		$errmsg.=" ($friend_id)" if($warning);
		$errmsg.=" : NG ($_)";
		print "$errmsg<br>\n";
		return ($errmsg,0);
	}

	# ɲåꥯȤ
	%hiddendata=($content=~/<input name="?([^\s"]*)"? type="?hidden"? value="?([^>"]*)"?/g);

	$hiddendata{submit}="confirm"; #ǧ

	$postdata="";
	$postdata=join('&',map{"$_=$hiddendata{$_}"}keys %hiddendata);
	$postdata.="&subject=".&url_encode($subject);
	$postdata.="&body=".&url_encode($body);
	$postdata.="&yes=";

	($content,$header)=&http_post($page,$referer,\%cookie,$postdata);
	$referer=$page;

	$errmsg=&mixi_errmsg($content,$header,$referer);
	if($errmsg=~/λ/) {
		$_=$errmsg;
		$errmsg="mixiå";
		$errmsg.=" ($friend_id)" if($warning);
		$errmsg.=" : OK ($_)";
		print "$errmsg<br>\n";
	}
	else {
		$_=$errmsg;
		$errmsg="mixiå";
		$errmsg.=" ($friend_id)" if($warning);
		$errmsg.=" : NG ($_)";
		print "$errmsg<br>\n";
		return ($errmsg,0);
	}

	return ($errmsg,1);
}

sub mixi_errmsg() {
	my ($content,$header,$referer)=@_;
	my ($page,%cookie,$postdata);
	my ($errmsg,$success);
	my (@errmsg,@msg);

	@msg=();
	@errmsg=();

	# <title>
	#if($content=~m!<title>([^<]*)</title>!i) {
	#	push @errmsg,$1;
	#}
	#else {
	#	push @errmsg,"";
	#}

	# <html>˥顼å
	if($content=~m!\s*(.*)\s*<html>!i) {
		push @errmsg,$1 if($1);
	}

	# 󥨥顼
	if($content=~m!<form action="?login.pl"? method="?post"?>!i) {
		push @errmsg,"Ǥޤ";
	}
	if($content=~m!<meta http-equiv="refresh" content="0;url=/check.pl\?n=%2Fhome.pl">!i){
		push @errmsg,"󤷤ޤ";
	}

	# ɥ/ᥤå
	if(@msg=($content=~m!<td WIDTH="?\d+"? background="?http://img.mixi.jp/img/bg_w.gif"?>(?:<font COLOR="?#[0-9a-f]{6}"?>|<b>|\s)*([^<]*)(?:</b>|</font>|\s)*</td>!ig)) {
		push @errmsg,@msg;
	}
	# ɥ/֥å
	if(@msg=($content=~m!<tr>\s*<td ALIGN=right BGCOLOR=#EED6B5>(?:<br>|\s)*([^<]*)!ig)) {
		push @errmsg,@msg;
	}
	# ɥ/֥å/᡼(ޤ⤢ޤ)
	if(@msg=($content=~m!<img src="?http://img.mixi.jp/img/nothing.gif"?!ig)) {
		push @errmsg,"ޤ⤢ޤ";
	}
	# ϻ/֥å/񼰥1
	if(@msg=($content=~m!<tr>\s*<td ALIGN=center BGCOLOR=#EED6B5(?: CLASS=h120)?>(?:<br>|\s)*([^<]*)!ig)) {
		push @errmsg,@msg;
	}
	# ϻ/֥å/񼰥2
	if(@msg=($content=~m!<table [^<]*BGCOLOR=#EED6B5>\s*<tr>\s*<td ALIGN=center>([^<]*)</td>!ig)) {
		push @errmsg,@msg;
	}
	# ϳǧ/֥å/YesNoǧ(ˡ)
	if(@msg=($content=~m!<td COLSPAN="?2"?>([^<]*)</td>!ig)) {
		push @errmsg,@msg;
	}
	# λ/֥å/᡼(񤷤ޤ)
	if(@msg=($content=~m!<img src=http://img.mixi.jp/img/part.gif WIDTH=31 HEIGHT=29></td>!ig)) {
		push @errmsg,"񤷤ޤ";
	}
	# λ/֥å/᡼(λޤ)
	if(@msg=($content=~m!<img src=http://img.mixi.jp/img/mail_send.gif WIDTH=25 HEIGHT=28></td>!ig)) {
		push @errmsg,"λޤ";
	}
	# λ/֥å/񼰥1
	if(@msg=($content=~m!<table BORDER="?0"? CELLSPACING="?0"? CELLPADDING="?5"?>\s*<tr>\s*<td>(?:<b>|\s)*([^<]*)(?:</b>|\s)*</td>\s*</tr>\s*</table>!ig)) {
		push @errmsg,@msg;
	}
	# ֻ顼
	if(@msg=($content=~m!<b><font color="?#DD0000"?>([^<]*)</font></b></br>!ig)) {
		push @errmsg,@msg;
	}

	# ư
	#if($content=~m!^(HTTP/[\d\.]* \d+ [^\r\n]*)!i) {
	#	$errmsg=$1;
	#	if($errmsg=~m!^HTTP/[\d\.]* 302 Moved!i) {
	#		$header=~/Location: *([^\s]*)/;
	#		$page="http://mixi.jp/$1";
	#		($content,$header)=&http_get($page,$referer,\%cookie);
	#		$referer=$page;
	#		return &mixi_errmsg($content,$header,$referer);
	#	}
	#}
	return join(" > ",@errmsg);
}

1;
