######################################################################
sub load_file() {
######################################################################
	my ($filename,$buf)=@_;
	my ($size);

	$size=(stat($filename))[7];
	if($size && open(IN,"<$filename")) {
		binmode(IN);
		if(sysread(IN,$$buf,$size)) {
			close(IN);
			return 1;
		}
		else {
			close(IN);
			return 0;
		}
	}
	else {
		return 0;
	}
}

######################################################################
sub save_file() {
######################################################################
	my ($filename,$buf)=@_;
	my ($size);

	$size=length($buf);
	if($size && open(OUT,">$filename")) {
		binmode(OUT);
		if(syswrite(OUT,$buf,$size)) {
			close(OUT);
			return 1;
		}
		else {
			close(OUT);
			return 0;
		}
	}
	else {
		return 0;
	}
}

1;
