require 'file_rw.pl';
require 'ppm.pl';
require 'pgm.pl';
require 'template.pl';
require 'statistics.pl';
#use Statistics::Lite qw(min max sum mean median);

sub migr_gifreader() {
	my ($invite_key)=@_;
	my (@dir,$filename,$filepath);
	my ($ppm,$pgm,$image_t,$number_t,%reading);
	my ($logfile,$cache_use,$template_file);

	# Ƽ
	$logfile="$datadir/gif_reading.log";
	$template_file="$datadir/number.template";
	$cache_use=1; # 0: ϤԤ
                # 1: ˲Ϥǧֹ֤($logfile)

	# βϷ̤ɤ߹
	if(open IN,"<$logfile") {
		foreach(<IN>) {
			s/[\r\n]//g;
			/^([^\t]*)\t([^\t]*)$/;
			$reading{$1}=$2;
		}
		close IN;
	}

	# ե
	$filename="$invite_key.gif";
	$filepath="$datadir/$filename";

	# ˲Ϥǧֹ֤
	if($cache_use && exists $reading{$filename}) {
		return (1,$reading{$filename});
	}

	# оݲ
	if(!-e $filename) {
		if($debug) {
			if(system("wget -O\"$filepath\" http://mixi.jp/data/gif/$filename")) {
				print "<br>";
				return (0,"");
			}
		}
		else {
			if(system("wget -q -O\"$filepath\" http://mixi.jp/data/gif/$filename")) {
				return (0,"");
			}
		}
	}

	# ǧѥƥץ졼Ȥ
	$number_t=&template_load($template_file) || return 0;

	# оݲ
	if(! &ppm_load($filepath,\$ppm)) {
		unlink($filepath);
		return (0,"");
	}
	unlink($filepath);

	# оݲ
	&ppm_filter_erase_color($ppm); # 顼ʬä

	$pgm=&ppm_to_pgm($ppm); # 졼Ȥpgmǰ
	#&pgm_save('out_image0.pgm',$pgm);

	$pgm=&pgm_filter_oneline($pgm); # ե륿
	#&pgm_save('out_image1.pgm',$pgm);

	$pgm=&pgm_filter_bipixelize($pgm); # Ͳ
	#&pgm_save('out_image2.pgm',$pgm);

	$pgm=&pgm_filter_oneline($pgm); # ե륿
	#&pgm_save('out_image3.pgm',$pgm);

	$image_t=&pgm_make_template($pgm); # ƥץ졼Ȥ
	#&template_save(">image.template",$image_t);

	# ưƥץ졼ȥޥå󥰤ˤǧ
	$reading{$filename}=&template_dynamic_match_retry($image_t,$number_t); # ƥץ졼ȥޥå
	print "ǧڲɤ߼ : \"$reading{$filename}\"\n" if($debug);

	return (0,"") if(! exists $reading{$filename});

	# Ϸ̤¸
	if(open OUT,">>$logfile") {
		print OUT "$filename\t$reading{$filename}\n";
		close OUT;
	}
	return (1,$reading{$filename});
}

1;
