sub min() {
	my (@array)=@_;
	return (sort{$a<=>$b}@array)[0];
}

sub max() {
	my (@array)=@_;
	return (sort{$b<=>$a}@array)[0];
}

sub median() {
	my (@array)=@_;
	my ($i,$j);

	@array=sort{$a<=>$b}@array;
	if(scalar(@array)%2) {
		return $array[int(scalar(@array)/2)];
	}
	else {
		$i=$array[int(scalar(@array)/2)];
		$j=$array[int(scalar(@array)/2)-1];
		return ($i+$j)/2;
	}
}

sub sum() {
	my (@array)=@_;
	my ($sum);

	$sum=0;
	foreach(@array) {
		$sum+=$_;
	}
	return $sum;
}

sub mean() {
	my (@array)=@_;

	if(scalar(@array)>0) {
		return &sum(@array)/scalar(@array);
	}
}

#=========================
# 򺮤
#=========================
# @list=shuffle(@list);
sub shuffle() {
	my (@list)=@_;
	my ($i,$rand,$tmp);

	foreach $i(0..$#list) {
		$rand=int(rand(scalar @list));
		$tmp=$list[$i];
		$list[$i]=$list[$rand];
		$list[$rand]=$tmp;
	}
	return @list;
}

1;
